#include <fcntl.h>
#include <unistd.h>
int real_main(void);
int main() {
	close(0); open("asfalt.in", O_RDONLY);
	close(1); open("asfalt.out", O_WRONLY | O_CREAT | O_TRUNC, 0666);
	return real_main();
}
#define main real_main

#include <stdio.h>
#include <stdlib.h>

#define G	if (1)

#define C2I(c)	((c)/M)
#define C2J(c)	((c)%M)
#define IJ2C(i,j)		((i)*M + (j))
#define V(i,j)	v[IJ2C(i,j)]
#define PX(i,j)	px[IJ2C(i,j)]
#define PY(i,j)	py[IJ2C(i,j)]
#define C(i,j)	c[IJ2C(i,j)]
#define L(i,j)	l[IJ2C(i,j)]
#define R(i,j)	r[IJ2C(i,j)]
#define T(i,j)	t[IJ2C(i,j)]
#define B(i,j)	b[IJ2C(i,j)]

#define MAX	1000000
#define MAXL	1000



int M,N,cS,cM,cT;
int v[MAX];
int px[MAX];
int py[MAX];
long long int c[MAX];
int l[MAX];
int r[MAX];
int t[MAX];
int b[MAX];

struct buf {
	int pos;
	int height;
};

struct qnode {
	int i,j;
	long long int c;
};

int all[MAX + MAXL] = {0};
int pointers[MAX + MAXL] = {0};
int QK;

/*void debug_queue(void) {
	for (int i=0;i<QK;i++) printf("%d(%Ld)%c", all[i], c[all[i]], (i+1==QK) ? '\n' : ' ');
}*/

void heap_fixup(int I) {
	for (int i=I;i>1;i/=2) {
		if (c[all[i/2-1]] > c[all[i-1]]) {
			int tmp = all[i/2-1];
			all[i/2-1] = all[i-1];
			all[i-1] = tmp;
			pointers[all[i-1]] = i;
			pointers[all[i/2-1]] = i/2;
		}
	}
}

void queue_push(int I, int J) {
	if (pointers[IJ2C(I,J)] == 0) // nen v hald
	{
//		printf("push add %d %d\n", I, J); // debug
		// vloen
		all[QK] = IJ2C(I,J);
		QK++;
		pointers[IJ2C(I,J)] = QK;
		
		// oprava haldy
		heap_fixup(QK);
	}
	else {	// u byl v hald
//		printf("push mv  %d %d\n", I, J); // debug
		heap_fixup(pointers[IJ2C(I,J)]);
	}
//	debug_queue();
}

struct qnode queue_pop(void) {
	// vyjmut
	if (QK == 0) exit(1);
	struct qnode o;
	o.i = C2I(all[0]);
	o.j = C2J(all[0]);
	pointers[all[0]] = 0;
//	printf("pop      %d %d\n", o.i, o.j); //debug
	QK--;
	all[0] = all[QK];

	// oprava haldy
	int i=1;
	while (i <= QK/2) {
		if ((i*2 == QK) || (c[all[2*i-1]] < c[all[2*i]])) {
			if (c[all[i-1]] > c[all[2*i-1]]) {
				int tmp = all[i*2-1];
				all[i*2-1] = all[i-1];
				all[i-1] = tmp;
				pointers[all[i-1]] = i;
				pointers[all[i*2-1]] = i*2;
				i *= 2;
			} else {
				break;
			}
		} else if (i*2 < QK) {
			if (c[all[i-1]] > c[all[2*i]]) {
				int tmp = all[i*2];
				all[i*2] = all[i-1];
				all[i-1] = tmp;
				pointers[all[i-1]] = i;
				pointers[all[i*2]] = i*2 + 1;
				i *= 2;
				i++;
			} else {
				break;
			}
		}
	}

//	debug_queue();
	return o;
}

void output() {
	printf("%Ld\n",C(0,0));
	int i=0,j=0;
	while ((i!=N-1) || (j!=M-1)) {
		printf("%d %d\n", i, j);
		int ti = PY(i,j), tj = PX(i,j);
		i=ti; j=tj;
	}
	printf("%d %d\n", i, j);
}

void work(int i, int j, int ii, int jj, long long int cc) {
//	printf("%d,%d->%d,%d, %lld\n",i,j,ii,jj,cc); // debug
	// kontrola na vyteen z prostoru
	if (ii < 0) return;
	if (ii >= N) return;
	if (jj < 0) return;
	if (jj >= M) return;

	// kontrola na peven
	int d = V(i,j) - V(ii,jj);
	if ((d > 1) || (d < -1)) return;

	// kontrola, jestli jsme levnj
	if ((C(ii,jj) > 0) && (C(ii,jj) < C(i,j) + cc)) return;
	
	PX(ii,jj) = j;
	PY(ii,jj) = i;
	C(ii,jj) = C(i,j) + cc;

	// zadn
	queue_push(ii,jj);
//	printf("Y\n"); // debug
}

void precount(int I, int J, int sign) { // sign = 1 -> most, sign = -1 -> tunel
	// -1 mus bt nastavena ta promnn, pes kterou se m iterovat
	// prvn je pedpoet dku, druh v sloupci
#define D(a,b) (J == -1 ? (a) : (b))
	struct buf buff[MAXL];

	int K = 0;
	buff[0].height = D(V(I,0),V(0,J));
	buff[0].pos = 0;
	for (int it=1;it<D(M,N);it++) {
		while (sign*buff[K].height > sign*D(V(I,it),V(it,J))) {
			if (K-- == 0) break;
		}
		if ((K >= 0) && (buff[K].height == D(V(I,it),V(it,J)))) {
			if (buff[K].pos != it-1) {
				if (J == -1) {
					L(I,it) = buff[K].pos;
					R(I,buff[K].pos) = it;
				} else {
					T(it,J) = buff[K].pos;
					B(buff[K].pos,J) = it;
				}
			}
			buff[K].pos = it;
		} else {
			K++;
			buff[K].pos = it;
			buff[K].height = D(V(I,it),V(it,J));
		}
	}
}

int main(void) {
	// cteni vstupu
	scanf("%d%d%d%d%d",&N,&M,&cS,&cM,&cT);

	for (int i=0;i<N;i++)
		for (int j=0;j<M;j++) {
			scanf("%d",&V(i,j));
		}

	// inicializace ukazatel mimo plochu
	for (int i=0;i<N;i++)
		for (int j=0;j<M;j++) {
			R(i,j) = -1;
			T(i,j) = -1;
			B(i,j) = -1;
			L(i,j) = -1;
		}
	// pedpoet most a tunel pro kad dek
	for (int i=0;i<N;i++) {
		precount(i,-1,1);
		precount(i,-1,-1);
	}
	// pedpoet most a tunel pro kad sloupec
	for (int j=0;j<M;j++) {
		precount(-1,j,1);
		precount(-1,j,-1);
	}

	PX(N-1,M-1) = M-1;
	PY(N-1,M-1) = N-1;
	C(N-1,M-1) = cS;
	queue_push(N-1, M-1);
	while (QK != 0) {
		struct qnode q = queue_pop();
		int i = q.i;
		int j = q.j;
		// kontrola na cl
		if ((i == 0) && (j == 0)) {
			output();
			exit(0);
		}
		// soused
		work(i, j, i+1, j, cS);
		work(i, j, i-1, j, cS);
		work(i, j, i, j+1, cS);
		work(i, j, i, j-1, cS);
		if (L(i,j) != -1) work(i, j, i, L(i,j), (V(i,j-1)<V(i,j) ? cM : cT)*(j-L(i,j)-1) + cS);
		if (R(i,j) != -1) work(i, j, i, R(i,j), (V(i,j+1)<V(i,j) ? cM : cT)*(R(i,j)-j-1) + cS);
		if (T(i,j) != -1) work(i, j, T(i,j), j, (V(i-1,j)<V(i,j) ? cM : cT)*(i-T(i,j)-1) + cS);
		if (B(i,j) != -1) work(i, j, B(i,j), j, (V(i+1,j)<V(i,j) ? cM : cT)*(B(i,j)-i-1) + cS);
	}
	printf("NEEXISTUJE\n");
	return 0;
}
