#if 1
#include <fcntl.h>
#include <unistd.h>
int real_main(void);
int main() {
	close(0); open("asfalt.in", O_RDONLY);
	close(1); open("asfalt.out", O_WRONLY | O_CREAT | O_TRUNC, 0666);
	return real_main();
}
#define main real_main
#endif

#include <stdio.h>
#include <stdlib.h>

typedef unsigned long long ull;

int R, S;
ull cS, cM, cT;

#define MAXRS 1000
#define MAXP (MAXRS*MAXRS+1)
#define MAXC 1000000
#define MAXH 1000000
#define INFTY (1ULL<<62)

#define ASSERT(cond) do { if (!(cond)) { fprintf(stderr, "BUG: " #cond "\n"); exit(1); } } while(0)

int h[MAXRS][MAXRS];
int hint[MAXRS][MAXRS][4];	// L,R,T,B

#define E(i,j) ((i)*MAXRS + (j))
#define D(i,j,c) i = (c)/MAXRS, j = (c)%MAXRS
ull best[MAXP];
int prev[MAXP];

#if 0

// Bellman-Ford

int queue[MAXP];
int in_queue[MAXP];
int qr, qw;

static void heap_set(int i, ull new)
{
  best[i] = new;
  if (!in_queue[i])
    {
      in_queue[i] = 1;
      queue[qw] = i;
      qw = (qw+1) % MAXP;
    }
}

static int heap_delmin(void)
{
  if (qr == qw)
    return -1;
  int i = queue[qr];
  qr = (qr+1) % MAXP;
  in_queue[i] = 0;
  return i;
}

#else

// Dijkstra

int heap[MAXP];
int hcnt;
int back[MAXP];

static inline void swap(int i, int j)
{
  int z = heap[i];
  heap[i] = heap[j];
  heap[j] = z;
  back[heap[i]] = i;
  back[heap[j]] = j;
}

static void heap_set(int i, ull new)
{
  ASSERT(new <= best[i]);
  best[i] = new;
  if (back[i])
    i = back[i];
  else
    {
      heap[++hcnt] = i;
      back[i] = hcnt;
      i = hcnt;
    }
  while (i > 1 && best[heap[i/2]] > best[heap[i]])
    {
      swap(i, i/2);
      i /= 2;
    }
}

static int heap_delmin(void)
{
  if (!hcnt)
    return -1;
  int old = heap[1];
  swap(1, hcnt);
  hcnt--;

  int i = 1;
  while (2*i <= hcnt)
    {
      int j = 2*i;
      if (j+1 <= hcnt && best[heap[j+1]] < best[heap[j]])
	j++;
      if (best[heap[i]] < best[heap[j]])
	break;
      swap(i, j);
      i = j;
    }

  back[old] = 0;
  return old;
}

#endif

#if 0

int DI[4] = { 0, 0, -1, 1 };
int DJ[4] = { -1, 1, 0, 0 };

static void precalc(void)
{
  for (int i=0; i<R; i++)
    for (int j=0; j<S; j++)
      for (int d=0; d<4; d++)
	{
	  int di=DI[d], dj=DJ[d];
	  int ii=i, jj=j;
	  int ht=h[i][j], min=ht, max=ht;
	  int steps = 0;
	  for (;;)
	    {
	      ii += di, jj += dj;
	      if (ii < 0 || ii >= R || jj < 0 || jj >= S)
		break;
	      steps++;
	      if (h[ii][jj] == ht)
		{
		  if (ii != i+di || jj != j+dj)
		    hint[i][j][d] = steps;
		  break;
		}
	      if (h[ii][jj] < min)
		min = h[ii][jj];
	      if (h[ii][jj] > max)
		max = h[ii][jj];
	      if (min != ht && max != ht)
		break;
	    }
	  // printf("Hint %d %d %d = %d\n", i, j, d, hint[i][j][d]);
	}
}

#else

struct pt { int i, j, h; };
static struct pt stack[MAXRS+4];

static void precalc2(int d, int i0, int j0, int bi, int bj, int si, int sj)
{
  while (i0 >= 0 && i0 < R && j0 >= 0 && j0 < S)
    {
      for (int s=-1; s<=1; s+=2)
	{
	  int i=i0, j=j0;
	  int sp = 0;
	  stack[0] = (struct pt) { 0, 0, MAXH+1 };
	  while (i >= 0 && i < R && j >= 0 && j < S)
	    {
	      int ht = s*h[i][j];
	      while (ht > stack[sp].h)
		sp--;
	      if (ht == stack[sp].h)
		{
		  int dist = abs(stack[sp].i - i) + abs(stack[sp].j - j);
		  if (dist > 1)
		    hint[i][j][d] = dist;
		  sp--;
		}
	      stack[++sp] = (struct pt) { i, j, ht };
	      i += si, j += sj;
	    }
	}
      i0 += bi, j0 += bj;
    }
}

static void precalc(void)
{
  precalc2(0, 0, 0, 1, 0, 0, 1);
  precalc2(1, 0, S-1, 1, 0, 0, -1);
  precalc2(2, 0, 0, 0, 1, 1, 0);
  precalc2(3, R-1, 0, 0, 1, -1, 0);
}

#endif

static void try(int x, int i, int j, ull cost)
{
  if (i < 0 || i >= R || j < 0 || j >= S)
    return;
  int ii, jj;
  D(ii, jj, x);
  ASSERT(ii == i || jj == j);
  if (h[ii][jj] > h[i][j]+1 || h[ii][jj] < h[i][j]-1)
    return;
  cost += best[x];
  int y = E(i,j);
  if (cost < best[y])
    {
      heap_set(y, cost);
      prev[y] = x;
    }
}

int main(void)
{
  scanf("%d%d%lld%lld%lld", &R, &S, &cS, &cM, &cT);
  ASSERT(R > 0 && R <= MAXRS);
  ASSERT(S > 0 && S <= MAXRS);
  ASSERT(cS > 0 && cS <= MAXC);
  ASSERT(cM > 0 && cM <= MAXC);
  ASSERT(cT > 0 && cT <= MAXC);

  for (int i=0; i<R; i++)
    for (int j=0; j<S; j++)
      {
	scanf("%d", &h[i][j]);
	ASSERT(h[i][j] >= 0 && h[i][j] <= MAXH);
	best[E(i,j)] = INFTY;
      }

  precalc();

  heap_set(E(R-1,S-1), cS);
  int x;
  while ((x = heap_delmin()) >= 0)
    {
      int i, j;
      D(i, j, x);
      try(x, i, j-1, cS);
      try(x, i, j+1, cS);
      try(x, i-1, j, cS);
      try(x, i+1, j, cS);
      if (hint[i][j][0])
	try(x, i, j - hint[i][j][0], ((h[i][j-1] < h[i][j]) ? cM : cT) * (hint[i][j][0]-1) + cS);
      if (hint[i][j][1])
	try(x, i, j + hint[i][j][1], ((h[i][j+1] < h[i][j]) ? cM : cT) * (hint[i][j][1]-1) + cS);
      if (hint[i][j][2])
	try(x, i - hint[i][j][2], j, ((h[i-1][j] < h[i][j]) ? cM : cT) * (hint[i][j][2]-1) + cS);
      if (hint[i][j][3])
	try(x, i + hint[i][j][3], j, ((h[i+1][j] < h[i][j]) ? cM : cT) * (hint[i][j][3]-1) + cS);
    }
  if (best[E(0,0)] < INFTY)
    {
      printf("%lld\n", best[E(0,0)]);
      int pos = 0;
      do
	{
	  int i, j;
	  D(i, j, pos);
	  printf("%d %d\n", i, j);
	  pos = prev[pos];
	}
      while (pos != E(R-1,S-1));
      printf("%d %d\n", R-1, S-1);
    }
  else
    puts("NEEXISTUJE");

  return 0;
}
