/* Judge to P-III-4. Call as ./judge <input> <given_output> <author_output> 
 * JMQ 2010 <moskyto@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define IJ2C(i,j)		((i)*M + (j))
#define V(i,j)	v[IJ2C(i,j)]
#define L(i,j)	l[IJ2C(i,j)]
#define R(i,j)	r[IJ2C(i,j)]
#define T(i,j)	t[IJ2C(i,j)]
#define B(i,j)	b[IJ2C(i,j)]

#define MAX 1000000
#define MAXL 1000

int die(const char* croak) {
	fprintf(stderr, "%s\n", croak);
	exit(2);
	return 0;
}
void bad(const char* croak) {
	fprintf(stderr, "%s\n", croak);
	exit(1);
}

struct buf {
	int pos;
	int height;
};

FILE *fin, *fout, *ftest;
int M,N,cS,cM,cT;
int v[MAX];
int l[MAX];
int r[MAX];
int t[MAX];
int b[MAX];

long long int given_cost;
long long int author_cost;

void precount(int I, int J, int sign) { // sign = 1 -> most, sign = -1 -> tunel
	// -1 mus bt nastavena ta promnn, pes kterou se m iterovat
	// prvn je pedpoet dku, druh v sloupci
#define D(a,b) (J == -1 ? (a) : (b))
	struct buf buff[MAXL];

	int K = 0;
	buff[0].height = D(V(I,0),V(0,J));
	buff[0].pos = 0;
	for (int it=1;it<D(M,N);it++) {
		while (sign*buff[K].height > sign*D(V(I,it),V(it,J))) {
			if (K-- == 0) break;
		}
		if ((K >= 0) && (buff[K].height == D(V(I,it),V(it,J)))) {
			if (buff[K].pos != it-1) {
				if (J == -1) {
					L(I,it) = buff[K].pos;
					R(I,buff[K].pos) = it;
				} else {
					T(it,J) = buff[K].pos;
					B(buff[K].pos,J) = it;
				}
			}
			buff[K].pos = it;
		} else {
			K++;
			buff[K].pos = it;
			buff[K].height = D(V(I,it),V(it,J));
		}
	}
}

int main(int argc, char ** argv) {
	int stat;
#define S(x)	if ((stat == EOF) || (stat == 0)) die(x)
#define BAD(x)	if ((stat == EOF) || (stat == 0)) bad(x)
	if (argc < 4) die("not enough args.");
	int no_sol = 0;
	char linebuf[256], *nl;
	
	(fout = fopen(argv[3], "r")) || die("Cannot open author output.");
	if (!fgets(linebuf, sizeof(linebuf), fout)) die("Error reading author output");
	if (nl = strchr(linebuf, '\n'))
		*nl = 0;
	if (!strcmp(linebuf, "NEEXISTUJE"))
		no_sol = 1;
	else if (sscanf(linebuf, "%Ld", &author_cost) != 1) die("Author output read error.");
	fclose(fout);
	
	(fin = fopen(argv[1], "r")) || die("Cannot open input.");
	stat = fscanf(fin, "%d%d%d%d%d",&N,&M,&cS,&cM,&cT); S("Input read error");

	for (int i=0;i<N;i++)
		for (int j=0;j<M;j++) {
			stat = fscanf(fin, "%d",&V(i,j)); S("Input read error");
		}
	fclose(fin);
	
	// inicializace ukazatel mimo plochu
	for (int i=0;i<N;i++)
		for (int j=0;j<M;j++) {
			R(i,j) = -1;
			T(i,j) = -1;
			B(i,j) = -1;
			L(i,j) = -1;
		}
	// pedpoet most a tunel pro kad dek
	for (int i=0;i<N;i++) {
		precount(i,-1,1);
		precount(i,-1,-1);
	}
	// pedpoet most a tunel pro kad sloupec
	for (int j=0;j<M;j++) {
		precount(-1,j,1);
		precount(-1,j,-1);
	}

	(ftest = fopen(argv[2], "r")) || die("Cannot open given output.");
	if (!fgets(linebuf, sizeof(linebuf), ftest)) die("Error reading output file");
	if (nl = strchr(linebuf, '\n'))
		*nl = 0;
	if (!strcmp(linebuf, "NEEXISTUJE")) {
	    	if (no_sol)
			return 0;
		bad("Claims no solution where there is one.");
	}
	if (no_sol)
		bad("Claim solution where none exists.");
	if (sscanf(linebuf, "%Ld", &given_cost) != 1) bad("Expecting cost.");

	int i,j,ni,nj;
	long long int c=cS;
	stat = fscanf(ftest, "%d%d", &i,&j); BAD("No path supplied.");
	if(i || j) bad("The path must begin at (0,0).");

	while((stat = fscanf(ftest, "%d%d", &ni,&nj)) != EOF) {
		BAD("Malformed data.");
		if ((ni == i) && (nj == j)) bad("Repeating field.");
		if ((ni != i) && (nj != j)) bad("Diagonal moves not allowed.");
		if ((ni < 0) || (ni >= N) || (nj < 0) || (nj >= M)) bad("Leaving the world not allowed.");
		if (abs(ni-i)+abs(nj-j) != 1) { // bridge/tunnel
			if (ni < i) { // top
				if (T(i,j) != ni) bad("Bad bridge/tunnel.");
				c += (V(i-1,j) < V(i,j) ? cM : cT)*(i-ni-1);
			} else if (ni > i) { // bottom
				if (B(i,j) != ni) bad("Bad bridge/tunnel."); 
				c += (V(i+1,j) < V(i,j) ? cM : cT)*(ni-i-1);
			} else if (nj < j) { // left
				if (L(i,j) != nj) bad("Bad bridge/tunnel."); 
				c += (V(i,j-1) < V(i,j) ? cM : cT)*(j-nj-1);
			} else if (nj > j) { // right
				if (R(i,j) != nj) bad("Bad bridge/tunnel."); 
				c += (V(i,j+1) < V(i,j) ? cM : cT)*(nj-j-1);
			} else {
				die("Error in matrix.");
			}
		} else { // just a step
			if (abs(V(i,j)-V(ni,nj)) > 1) bad("Fell down a rock. Height difference too big.");
		}
		i = ni;
		j = nj;
		c += cS;
	}
	if ((i != N-1) || (j != M-1)) bad("The path must end at (N-1, M-1).");
	if (c != given_cost) bad("Given cost and counted cost differ.");
	if (given_cost > author_cost) bad("Given cost higher than author cost.");
	return 0;
}
